/*#include <8052.h>*/
#include <reg1210.h>
#include <stdio.h>
//#include "ulan.h"
//#include "ul_util.h"
#include <string.h>

#include <system_def.h>
#include <usb/pdiusb.h>
#include <usb/usb.h>
#include <usb/pdi.h>
#include <usb/usbdebug.h>
//#include "vendor.h"


bit My_Bit;

//xdata USB_DEVICE_REQUEST usb_request;
xdata usb_device_t usb_pdi_device;

unsigned char prog_flags;


unsigned char _sdcc_external_startup( void) {
  EA = 0;
  LED1=0;

  prog_flags = 0;

  
  #ifndef SDCC
  #pragma asm
  extrn code(?C_START)
  mov sp,#0C0h
  jmp ?C_START
  #pragma endasm
  #endif
  return 0;
}

void deb_wait(int delay)
{
  volatile int waste;
  while(delay--){
    for(waste=20;waste--;);
  }
}

int ser0_init(void)
{
  ES0=0;
  SCON0=0x50;
  PCON|=0x80;	/* Bd = OSC/12/16/(256-TH1) */

  RCLK=0;	/* Timer 1 for serial 0 receiver */
  TCLK=0;	/* Timer 1 for serial 0 transmitter */
  CKCON&=~0x10;	/* T1M = 0 => timer 1 clock is f/12 else f/4 */
  TR1=0;
  TH1=-5;
  TMOD&=0x0F;
  TMOD|=0x20;
  TR1=1;
  TI=1;
  return 0;
}

char getchar() {
  char c;
  while (!RI)
    ;
  RI=0;
  c=SBUF;
  return c;
}

void putchar(char c) {
  while (!TI)
    ;
  TI=0;
  SBUF=c;
  if (c=='\n') {
    putchar('\r');
  }
}

int dbg_print(char *s)
{
  while (*s){
    putchar(*(s++));
  }
  return 0;
}


int main()
{  
//  xdata uint8_t uc;
  bit send_fl;
  char c;
  int i;
  int loop_cnt1;
  int led_delay;
  usb_ep_t *ep0 = &(usb_pdi_device.ep0);

    
  memset( &usb_pdi_device, 0, sizeof( usb_pdi_device));

//  usb_pdi_device.request = &usb_request;
  usb_pdi_device.id = 1;
  usb_pdi_device.cntep = 0;
 #ifdef USB_WITH_UDEV_FNC
  usb_pdi_device.init = usb_pdi_init;
 #endif /*USB_WITH_UDEV_FNC*/
    
  LED1=0;
  IE=0; 	/* Disable all interrupts sources */
  ser0_init();

  usb_debug_level = 0;
  
  dbg_print("\n\rTest for USB\n\r");

  usb_init( &usb_pdi_device);
  
  LED1=1;
  deb_wait(500);
//  USBConnect();
  LED1=0;
  deb_wait(500);

  LED1=1;
  deb_wait(2000);
  EA=1;   // Enable interrupts
/*
  LED1=1;
  deb_wait(2000);
  i=0;
  send_fl=0;

  REGISTER_INT( #0x8403, #_extint_handler);
  dbg_print("ex0 init\r\n");
*/

  while(1){
  
/* USB */
    if ( !IPDI) { // preruseni od PDIUSBD11
//      usb_debug_print( DEBUG_LEVEL_HIGH, ("IPDI\n"));
      usb_check_events( &usb_pdi_device);
    } 

    if ( usb_control_response( &usb_pdi_device)) {
      continue; // again usb - quicker access
    }
       
    
    LED1=!LED1;
    for(loop_cnt1=0;loop_cnt1++<0x7fff;){
      if(RI || !IPDI) break;
      if(RI_1){
        putchar('_');
        led_delay=4;
        LED1=1;
      }
      if(TI_1){
        led_delay=4;
        LED1=1;
      }
    }
    usb_debug_print( DEBUG_LEVEL_LOW, ("."));
    if(RI){
      c=getchar();
      if(c>=0x20)
        printf("c'%c'\n",c);
      else
        printf("c%02X\n",c);
      switch(c){
        case 'p':
          printf("Printf test\n");
          break;
        case 'f':
          send_fl=!send_fl;
          break;

        case '1': if ( usb_debug_level < DEBUG_LEVEL_VERBOSE) usb_debug_level++; printf( "UsbDbgLev=%d\n", usb_debug_level); break;
        case '2': if ( usb_debug_level) usb_debug_level--; printf( "UsbDbgLev=%d\n", usb_debug_level); break;
        case 'c': usb_connect( &usb_pdi_device); break;
        case 'd': usb_disconnect( &usb_pdi_device); break;
        
        case 'o': printf( "CNF=0x%04X\n", pdiGetFrameNumber()); break;
//        case 'v': prog_flags = prog_flags ^ PFLG_DEBUG; printf("DPRINT = %1d\n", prog_flags & PFLG_DEBUG); break;
        case 'x': printf( "EX0=%d\n", EX0 = !EX0); break;
        case 'z': printf( "usb_ep0:ptr=%p,max=%d,size=%d,act=%d,efnc=%p\n", ep0->ptr, ep0->max_packet_size, ep0->size, ep0->actual, ep0->efnc); break;
        
      }
    }
    if(i++>=2){
      if(send_fl){
        i=0;
//        putchar('x');
//        test_msg1();
      }
    }
  }
}
